﻿@using RaisingStudio.ModuleGenerator.TemplateModels
@helper FieldType(Property property)
{
    switch(property.PropertyType)
    {
        case "DateTime":
        {
            @("DateTimeField")
            break;
        }
        case "decimal":
        {
            @("NumericField")
            break;
        }
        case "bool":
        {
            @("BooleanField")
            break;
        }
        default:
        {
            @("InputField")
            break;
        }
    }
}
using Orchard.Data.Migration;
using Orchard.ContentManagement.MetaData;
using Orchard.Core.Contents.Extensions;

namespace @(Model.Module.ModuleName)
{
    public class Migrations : DataMigrationImpl
    {
        public int Create()
        {
          @foreach(var entity in Model.Module.Entities)
          {
@:           #region @(entity.TypeName)
@:           ContentDefinitionManager.AlterTypeDefinition("@(entity.TypeName)",
@:                cfg => cfg
@:                  .WithPart("@(entity.TypeName)")
@:                  .WithPart("CommonPart" )
@:           );
@:
             if(entity.Properties != null && entity.Properties.Count() > 0)
             {
@:           ContentDefinitionManager.AlterPartDefinition("@(entity.TypeName)", 
@:                p => p
                  foreach(var property in entity.Properties)
                  {
@:                  .WithField("@(property.PropertyName)", f => f.OfType("@FieldType(property)").WithDisplayName("@(property.DisplayName)"))
                  }
@:           );
             }
@:           #endregion
          }            
            
          return 1;
        }
    }
}