﻿using System.Collections.Generic;
using Orchard.Environment.Extensions.Models;
using Orchard.Security.Permissions;

namespace @(Model.Module.ModuleName)
{
    public class Permissions : IPermissionProvider
    {
        @foreach(var entity in Model.Module.Entities)
        {
@:        public static readonly Permission Manage@(entity.TypeName) = new Permission { Description = "Manage @(entity.TypeName)", Name = "Manage@(entity.TypeName)" };
        }

        public virtual Feature Feature { get; set; }

        public IEnumerable<Permission> GetPermissions()
        {
            return new Permission[] {
                @foreach(var entity in Model.Module.Entities)
                {
@:                  Manage@(entity.TypeName),
                }
            };
        }

        public IEnumerable<PermissionStereotype> GetDefaultStereotypes()
        {
            return new[] {
                new PermissionStereotype {
                    Name = "Administrator",
                    Permissions = new Permission[] {
                        @foreach(var entity in Model.Module.Entities)
                        {
@:                          Manage@(entity.TypeName),
                        }
                    }
                },
                new PermissionStereotype {
                    Name = "Editor",
                    Permissions = new Permission[] {
                        @foreach(var entity in Model.Module.Entities)
                        {
@:                          Manage@(entity.TypeName),
                        }
                    }
                },
                new PermissionStereotype {
                    Name = "Moderator",
                },
                new PermissionStereotype {
                    Name = "Author",
                    Permissions = new Permission[] {
                        @foreach(var entity in Model.Module.Entities)
                        {
@:                          Manage@(entity.TypeName),
                        }
                    }
                },
                new PermissionStereotype {
                    Name = "Contributor",
                    Permissions = new Permission[] {
                        @foreach(var entity in Model.Module.Entities)
                        {
@:                          Manage@(entity.TypeName),
                        }
                    }
                },
            };
        }
    }
}

